#include <SupportDefs.h>
#include <string.h>
#include <ctype.h>
#include "CLanguageAddOn.h"

const int kMaxNameSize = 256;

const char *parseFunction(const char *text, CLanguageProxy& proxy)
{
	char nameBuf[kMaxNameSize], *name = nameBuf;
	int size = 0;
	int offset = text - proxy.Text();
	
	while (isalnum(*text) || *text == ':' || *text == '_')
	{
			if (size < kMaxNameSize - 1)
			{
				*name++ = *text++;
				size++;
			}
			else text++;
	}
	*name = 0;
	if (size)
		proxy.AddFunction(nameBuf, nameBuf, offset, false);

	return text;
}

const char *parseSection(const char *text, CLanguageProxy& proxy)
{
	char nameBuf[kMaxNameSize], *name = nameBuf;
	int size = 0;
	int offset = text - proxy.Text();
	
	while (*text == '[' || isalnum(*text) || *text == ' ' || *text == ']')
	{
		if (size < kMaxNameSize - 1)
		{
			*name++ = *text++;
			size++;
		}
		else text++;
	}
	*name = 0;
	if (size)
	{
		proxy.AddFunction(nameBuf, nameBuf, offset, true);
		if (!strncasecmp(nameBuf, "[Code Disassembly]", 18))
			proxy.AddSeparator();			
	}

	return text;
}


void ScanForFunctions(CLanguageProxy& proxy)
{
	const char *text = proxy.Text(), *max = text + proxy.Size();
	if (*max != 0)
		return;
	
	while (text < max)
	{
		switch (*text++)
		{
			case '[':
			{
				if (isalpha(*text--))
				{
					text = parseSection(text, proxy);
				}
				(*text++);
				break;
			}
			case 'F':
				if (!strncasecmp(text, "unction ", 8)) text = parseFunction(text + 8, proxy);
			break;
		}
	}
}
